How to Configure Frame Relay in the Cyclades-PC300 Interfaces
-------------------------------------------------------------

IMPORTANT: Frame Relay support is currently available only for the 2.2.x 
	   kernel series, and only for kernels 2.2.15 and above.

For Frame Relay, in addition to the information provided in the 
README.CONFIG file, you should create a file called ifcfg-pvcN for each 
PVC (Permanent Virtual Circuit) you run in the Frame Relay link.

In order to configure PC300 PVC interfaces, all you need to do is:
- Create or edit the appropriate ifcfg-hdlcN file, located at /etc/hdlc.
  As this is the Frame Relay master interface, you should remove all the 
  IP configuration fields from this file (i.e. the fields IPADDR, NETMASK, 
  POINTOPOINT, NETWORK and BROADCAST).
- Create or edit the appropriate ifcfg-pvcN files, located at /etc/hdlc, one 
  for each of the desired PVC's.
- Bring the master interface up (active), by calling 'ifup hdlcN'.
- To bring a PVC up (active), call 'ifup pvcN'.
- To bring a PVC down (inactive), call 'ifdown pvcN'.

IMPORTANT: For each PVC in use, there should be an ifcfg-pvcN configuration 
	   file. 
IMPORTANT: the PVC's should only go up *after* the master interface is up 
	   (i.e. after the equivalent 'ifup hdlcN' has been run).

An example of a ifcfg-pvcN file would be as follows:

DEVICE=pvc0
MASTERDEV=hdlc0
DLCI=16
IPADDR=10.0.0.2
POINTOPOINT=10.0.0.1
MTU=1500
ONBOOT=yes

The parameters supported in this configuration file (and examples of the use 
of each of them) are as follows:

 DEVICE		the PVC device in use (DEVICE=pvc0).
 MASTERDEV	the master network device for this PVC (MASTERDEV=hdlc0).
 DLCI		the Frame Relay DLCI number for this PVC (DLCI=16).
 IPADDR		the local PVC IP address (IPADDR=10.0.0.2).
 POINTOPOINT	the remote DLCI IP address (POINTOPOINT=10.0.0.1).
 MTU		the local interface Maximum Transfer Unit (MTU=1500).
 ONBOOT		defines whether the interface should be loaded on boot 
		(ONBOOT=yes).

