#ifndef _ENCODE_H
#define _ENCODE_H

//  If this is defined, random codes will be tested for a working one...
//  Otherwise, the encode and decode routines will be tested for validity.
#undef  CRACK
#define CRACK_LIMIT	(0xFFFFFFFFUL)

/////////////////////////////////////////////////////////////////////
//
//  Steps to encode
//	1.  Generate 32 bit check value from the 32 bit original to form enc1/2
//	2.  Add a constant to enc1 and enc2 -- one constant is negative
//	3.  Scramble the bits
//	4.  Apply the "randomizer"
//
//  Check Value = orig XOR -1589947563
#define CHECK_CONST  (-1589947563L)
//
//  Addition Constants
//      enc1 +=  485672374
//      enc2 += -938153651
#define ENC1_CONST  (485672374L)
#define ENC2_CONST  (-938153651L)
//
//  The randomizer uses the following constants
//	Bits	Start 	Count	Direction	Mask
//	6	0       17	Down
//	17	6	351	Up
//	25      23	8846	Down
//	9	48	243	Down
//	7	57	49	Up
#define COUNT1	(17)
#define MASK1	(0x36L)
#define MSB1	(1L<<5)
#define COUNT2  (351)
#define MASK2	(0x1143EL)
#define MSB2	(1L<<16)
#define COUNT3  (8846)
#define MASK3   (0x01200000L)
#define MSB3	(1L<<24)
#define COUNT4  (243)
#define MASK4   (0x01B9L)
#define MSB4	(1L<<8)
#define COUNT5  (49)
#define MASK5   (0x66L)
#define MSB5	(1L<<6)


#ifndef __GEN_UP__
#define __GEN_UP__
#define  gen_up(seed,mask)			\
    (((seed)&1)?(((seed)>>1) ^ (mask)):((seed)>>1))
#endif

#define gen_down(seed,mask,msb) \
    (((seed)&(msb))?((((seed)^(mask))<<1)|1):((seed)<<1))

#define gen_loop_up(seed,mask,count,tmp) \
    { for ((tmp)=0; (tmp)<(count); (tmp)++) {(seed) = gen_up((seed),(mask));}}

#define gen_loop_down(seed,mask,count,msb,tmp) \
    { for ((tmp)=0; (tmp)<(count); (tmp)++) {(seed) = gen_down((seed),(mask),(msb));}}

// Function declarations
int encode (long, long *, long *);
int decode (long *, long, long);

#endif /* _ENCODE_H */

